﻿namespace WFAParameters;

interface

uses
  System.Drawing,
  System.Collections,
  System.Collections.Generic,
  System.Windows.Forms,
  System.ComponentModel,
  System.Data,
  System.Data.SqlClient;

type
  /// <summary>
  /// Summary description for MainForm.
  /// </summary>
  MainForm = partial class(System.Windows.Forms.Form)
  private
      var xsqlCn:SqlConnection:= new SqlConnection();
      var xsqlCmd:SqlCommand;
      var xsqlDa:SqlDataAdapter;
      var xDs:DataSet ;
      method MainForm_Load(sender: System.Object; e: System.EventArgs);
      method toolStripButton1_Click(sender: System.Object; e: System.EventArgs);
  protected
    method Dispose(disposing: Boolean); override;
  public
    constructor;
  end;

implementation

{$REGION Construction and Disposition}
constructor MainForm;
begin
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent();

  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

method MainForm.Dispose(disposing: Boolean);
begin
  if disposing then begin
    if assigned(components) then
      components.Dispose();

    //
    // TODO: Add custom disposition code here
    //
  end;
  inherited Dispose(disposing);
end;
{$ENDREGION}

method MainForm.MainForm_Load(sender: System.Object; e: System.EventArgs);
begin
{$region Criar a Conexão}
  xsqlCn.ConnectionString := 
  "Data Source=Technologies\sql2008; Initial Catalog=AdventureWorks;"+
  "Integrated Security=false; User Id=sa; password=997220201";
  xsqlCn.Open();
  if (xsqlCn.State <> ConnectionState.Open) then
  begin
    MessageBox.Show("Aplicação não conectada com o banco de dados",
                    "Atenção",
                     MessageBoxButtons.OK,
                     MessageBoxIcon.Error
                   );
    exit;          
  end;
  {$endregion}
 
end;

method MainForm.toolStripButton1_Click(sender: System.Object; e: System.EventArgs);
begin
    var xinicio, xfim:DateTime;
    {$region Validar entrada de dados}
    try            
        xinicio:= Convert.ToDateTime(tbxInicio.Text);            
    except
        MessageBox.Show("Data Incorreta!","Atenção",MessageBoxButtons.OK,MessageBoxIcon.Error );
        tbxInicio.Focus();
        exit;           
    end;
    
    try
    
        xfim :=Convert.ToDateTime(tbxFim.Text);

    except
        MessageBox.Show("Data Incorreta!", "Atenção", MessageBoxButtons.OK, MessageBoxIcon.Error);
        tbxFim.Focus();
        exit;
    end;
    {$endregion}

    {$region Preparar o command}
    xsqlCmd:= new SqlCommand();
    xsqlCmd.Connection:= xsqlCn;
    xsqlCmd.CommandType:= CommandType.Text;
    xsqlCmd.CommandText:= "SELECT   [SalesOrderID]         "+
                                 "         ,[DueDate]             "+
                                 "         ,[SalesOrderNumber]    "+
                                 "         ,[PurchaseOrderNumber] "+
                                 "         ,[AccountNumber]       "+
                                 "         ,[SubTotal]            "+ 
                                 "         ,[TaxAmt]              "+
                                 "         ,[Freight]             "+
                                 "         ,[TotalDue]            "+
                                 "FROM [Sales].[SalesOrderHeader] "+
                                 "WHERE [OrderDate] BETWEEN @PINICIO AND @PFIM";
    {$endregion}
    
    {$region Criar os parâmetros}

    var psqlParamInicio:SqlParameter:= new SqlParameter();
    psqlParamInicio.DbType := DbType.Date;
    psqlParamInicio.Direction := ParameterDirection.Input;
    psqlParamInicio.ParameterName:= "@PINICIO";
    psqlParamInicio.SqlValue := xinicio;

    var psqlParamFim:SqlParameter:= new SqlParameter();
    psqlParamFim.DbType := DbType.Date;
    psqlParamFim.Direction := ParameterDirection.Input;
    psqlParamFim.ParameterName := "@PFIM";
    psqlParamFim.SqlValue := xfim;
    {$endregion}

    {$region Atribuir os Parametros para o Adapter}
    xsqlDa:= new SqlDataAdapter();
    xsqlDa.SelectCommand := xsqlCmd;
    xsqlDa.SelectCommand.Parameters.Add(psqlParamInicio);
    xsqlDa.SelectCommand.Parameters.Add(psqlParamFim);
    {$endregion}
            
    {$region Gerar o DataSet}
    var xdsParameter:DataSet := new DataSet();
    xsqlDa.Fill(xdsParameter);
    {$endregion}

    {$region Exibir Dados}
    dataGridView1.DataSource := xdsParameter;
    dataGridView1.DataMember := xdsParameter.Tables[0].TableName;
    {$endregion}  
end;

end.
